myega_drop_boxes/accounts/urls.py
from django.urls import path
from django.conf.urls import url
from . import views

app_name = 'accounts'

urlpatterns = [
    path('', views.create_submissionboxes_with_users, name='create_submissionboxes_with_users'),
    path('submissionboxes/list', views.SubmissionboxesListView.as_view(), name='submissionboxes_list'),
    path('accounts/list', views.SubmissionAccountListView.as_view(), name='account_list'),
    path('stablesids/list', views.AccountStableIDsListView.as_view(), name='stablesidst_list'),
    path('numbersavailable/list', views.EgaBoxNumbersAvailableListView.as_view(), name='numbersavailable_list'),
    path('detail/<pk>/', views.SubmissionBoxesDetailView.as_view(), name='submissionboxes_detail'),
    path('account/<pk>/', views.SubmissionAccountDetailView.as_view(), name='account_detail'),
    path('detail/account/<pk>/', views.modify_submissionboxes, name='sub_detail'),
    path('create/account/<pk>/', views.create_account, name='create_account'),
    path('find', views.find_account , name='find_account'),
    url(r'^search$', views.search , name='search'),
    #url(r'^searchega$', views.searchega , name='searchega'),
]

myega_drop_boxes/myega_drop_boxes/urls.py
from django.contrib import admin
from django.urls import path,include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('accounts.urls')),
]

myega_drop_boxes/accounts/models.py
from django.db import models
from django.utils import timezone
from django.core.validators import RegexValidator

# las cuentas asignadas . Un cuneta asignada tene diferentes emails, users
class SubmissionBoxes(models.Model):
    # pk, number, unico, se creará si sale como disponible en la base de ega_box disponibles
    ega_box_number = models.PositiveIntegerField(primary_key=True, unique=True)
    account_type = models.CharField(
        max_length=30, blank=True, null=True)  # texto no muy largo
    temporary_column = models.CharField(
        max_length=30, blank=True, null=True)  # texto
    account_opened_date = models.DateTimeField(
        default=timezone.now)  # fecha de hoy defecto
    password_changed_date = models.DateTimeField(blank=True, null=True)  # date
    rt_ticket = models.CharField(max_length=30, unique=True)  # ?
    emails = models.CharField(max_length=300)
    comments = models.TextField(blank=True, null=True)  # texto largo
    # default False, no hemos recibido el dta del cliente
    received_dta = models.BooleanField(default=False)
    # default False, no hemos enviado el dta al cliente
    sent_dta = models.BooleanField(default=False)
    days_passed_since_created_date = models.PositiveIntegerField(
        blank=True, null=True)  # defecto dias de la fecha account_opened_date- now

    class Meta:
        db_table = 'submissionboxes'
        

    def __str__(self):
        return str(self.ega_box_number)

    def get_users(self):
        return ', '.join(self.users.all().values_list('email', flat=True))





class User(models.Model):
    email = models.EmailField(max_length=100 ) # emails multiples, ajuntar por coma + espacio
    submissionboxes = models.ForeignKey(
        SubmissionBoxes,
        related_name='users', on_delete=models.CASCADE)

    class Meta:
        db_table = 'user'

    def __str__(self):
        return self.email



# las cuentas creadas2
class SubmissionAccounts(models.Model):
    # emails text email/s que se concatenaran con comas +espacios
    ega_box_number = models.PositiveIntegerField(unique=True,  primary_key=True)   # ega_ega_box_number  primary key number
    account_accession = models.CharField(max_length=50, unique=True)# text automatico, se recupera de AccountStableIDs
    emails = models.CharField(max_length=300)
    submission_type = models.CharField(max_length=60, blank=True, null=True) # text 3 opciones: (Sequence, Array, Phenotype)
    country = models.CharField(max_length=100)  # text autocompletado
    region = models.CharField(max_length=100)  # text
    institute_name = models.CharField(max_length=100)  # text autocompletado
    mapi = models.CharField(max_length=10, blank=True, null=True)  # text
    affiliation_project = models.CharField( max_length=50, blank=True, null=True)  # text
    center_name = models.CharField(max_length=80)  # text  autocompletado
    password = models.CharField(max_length=80)  # text
    comments = models.TextField(blank=True, null=True)  # text
    submission_box = models.ForeignKey(SubmissionBoxes, on_delete=models.CASCADE)  # One to One filed, hacer que el valor lo guarde por defecto
    created_date = models.DateTimeField(default=timezone.now)  # date now default

    def __str__(self):
        return '%s %s %s' % (self.ega_box_number, self.account_accession, self.emails)

    def get_counthry(self):
        self.country=', '.join(self.counthry.all().values_list('name', flat=True))
        return  self.country


class Country(models.Model):
    name = models.CharField(max_length=600)
    submissionAccounts_country = models.ForeignKey(
        SubmissionAccounts,
        related_name='counthry', on_delete=models.CASCADE)

    class Meta:
        db_table = 'country'

    def __str__(self):
        return self.name




# Relaciona los ega-box numbers y account accession
# de las cuentas creadas
class AccountStableIDs(models.Model):
    ega_box_text = models.CharField(primary_key=True, max_length=100, unique=True)
    submission_boxes = models.OneToOneField(
        SubmissionBoxes,
        on_delete=models.CASCADE
    )
    # text, pk, unique, fk de las cuentas creadas

    submission_account = models.OneToOneField(
        SubmissionAccounts,
        on_delete=models.CASCADE,
        blank=True, null=True
    )
    # text, pk, unique, fk de las cuentas creadas
    account_accession = models.CharField(max_length=50, unique=True)

    def __str__(self):
        return '%s %s' % (self.ega_box_text, self.account_accession)

# cuentas reservadas para descargar archivos,


class DownloadBoxes(models.Model):
    # ega_box_number , puedo estar o no en Submission account, one to one filed ?, pk
    box = models.PositiveIntegerField(primary_key=True)
    account_type = models.CharField(max_length=20)  # text
    re_distribution = models.BooleanField(default=False)  # text,
    tempory_col = models.CharField(max_length=60)  # text
    # email/s hay problema si tienen el mismo nombre,
    user = models.EmailField(max_length=70)
    account_opened_date = models.DateTimeField()
    # ? date preguntar para que sirve Aina . Relacionada con las cuentas creadas
    password_changed_date = models.DateTimeField()
    expired = models.BooleanField(default=False)  # boolen
    comments = models.TextField()  # text

    def __str__(self):
        return '%s %s' % (self.box, self.user)


# El Box_history te da el historial de uso
# de  los ega-box numbers (que usuarios han
# tenido ese ega-box number )
# cuando se crea la cuenta, tb se guarda en el historial
class BoxHistory(models.Model):
    # text ega_box_ number, no pk pr se puede repetir
    ega_name = models.CharField(max_length=100)
    user = models.EmailField(max_length=70)  # email/s
    account_opened_date = models.DateTimeField()  # date
    password_changed_date = models.DateTimeField()  # date
    comments = models.TextField()  # text
    created_date = models.DateTimeField(default=timezone.now)
# tiene el ega box numbers disponibles , el limite y el numero que hay

    def __str__(self):
        return '%s %s' % (self.ega_name, self.user)


# tabla de ega box numbers que estan disponibles 

class EgaBoxNumbersAvailable(models.Model):
    ega_numbers_disponibles = models.CharField(max_length=1000,primary_key=True) # string de los ega_box numbers disponibles
    ega_maxim =  models.PositiveIntegerField()
    quantity =  models.IntegerField() 

myega_drop_boxes/accounts/views.py
from django.shortcuts import render, redirect, reverse, get_list_or_404, get_object_or_404
from django.http import HttpResponse
from django.template import loader
from django.views import generic
from django.utils import timezone
from django.views.generic.detail import DetailView
from django.views.generic import TemplateView
from .forms import (
    SubmissionBoxesModelForm,
    UserFormset,
    FindSubmissionAccountForm,
    ModifySubBoxesModelForm,
    SubmissionAccountsModelForm,
    CountryFormset,
    EgaBoxNumbersAvailableModelForm
)
from .models import (
    SubmissionBoxes, 
    User, 
    SubmissionAccounts,
    Country,
    EgaBoxNumbersAvailable, 
    AccountStableIDs)
from django.core import serializers
import json


class SubmissionAccountDetailView(DetailView):
    model = SubmissionAccounts
    template_name = 'accounts/account_detail.html'


class SubmissionBoxesDetailView(DetailView):
    model = SubmissionBoxes
    template_name = 'accounts/submission_boxes_detail.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['now'] = timezone.now()
        return context


class AccountStableIDsListView(generic.ListView):
    model = AccountStableIDs
    context_object_name = 'accountStableIDs'
    template_name = 'accounts/accountStableIDs_list.html'


class SubmissionboxesListView(generic.ListView):
    model = SubmissionBoxes
    context_object_name = 'submissionboxes'
    template_name = 'accounts/list.html'

    def get_queryset(self):
        """Return all objects ordered by ega_box_number."""
        return SubmissionBoxes.objects.order_by('-account_opened_date')


class SubmissionAccountListView(generic.ListView):
    model = SubmissionAccounts
    context_object_name = 'accounts'
    template_name = 'accounts/account_list.html'

    def get_queryset(self):
        """Return all objects ordered by ega_box_number."""
        return SubmissionAccounts.objects.order_by('-created_date')


class EgaBoxNumbersAvailableListView(generic.ListView):
    model = EgaBoxNumbersAvailable
    context_object_name = 'numbers'
    template_name = 'accounts/ega_numbers_available_list.html'


def create_submissionboxes_with_users(request):
    template_name = 'accounts/submission_boxes_new.html'
    # GET es obtener infromacion del srvidor . Traer info. que esta en el servidor (base de datos)
    #
    ega_numbers_uso = list(SubmissionBoxes.objects.all(
    ).values_list('ega_box_number', flat=True))
    ega_numbers_disponibles = []

    for i in range(1, 35):
        if i not in ega_numbers_uso:
            ega_numbers_disponibles.append(i)
    pstr = ";".join([str(num) for num in ega_numbers_disponibles])
    list_int = [int(num) for num in pstr.split(";")]
    quan = len(list_int)
    #
    if request.method == 'GET':
        submissionboxesform = SubmissionBoxesModelForm(request.GET or None)
        formset = UserFormset(queryset=User.objects.none())
    # POST enviar info. desde el cliente para que sea procesada y actualice o agrugue inf. en el servidor(base de datos)
    elif request.method == 'POST':
        submissionboxesform = SubmissionBoxesModelForm(request.POST)

        num_formset = int(''.join(request.POST['form-TOTAL_FORMS']))
        list_emails = []
        for i in range(0, num_formset):
            list_emails.append(request.POST['form-'+str(i)+'-email'])
        string_emails = ', '.join(list_emails)
        formset = UserFormset(request.POST)
        if submissionboxesform.is_valid() and formset.is_valid():
            submissionboxes = submissionboxesform.save(commit=False)
            submissionboxes.emails = string_emails
            submissionboxes.save()
            ega_box_number = submissionboxesform.cleaned_data['ega_box_number']
            #
            ega_numbers_uso = list(SubmissionBoxes.objects.all(
            ).values_list('ega_box_number', flat=True))
            ega_numbers_disponibles = []

            for i in range(1, 35):
                if i not in ega_numbers_uso:
                    ega_numbers_disponibles.append(i)
            pstr = ";".join([str(num) for num in ega_numbers_disponibles])
            list_int = [int(num) for num in pstr.split(";")]
            quan = len(list_int)
            ega_a = EgaBoxNumbersAvailable.objects.create(
                ega_numbers_disponibles=pstr, ega_maxim=35, quantity=quan)
            #
            for form in formset:
                user = form.save(commit=False)
                user.submissionboxes = submissionboxes
                user.save()
            return redirect('accounts:submissionboxes_detail', ega_box_number)

    return render(request, template_name, {
        'submissionboxesform': submissionboxesform,
        'formset': formset,
        'pstr': pstr,
    })

# lo va a buscar en las dos tablas : submissiion boxes, submission account


def find_account(request):
    form = FindSubmissionAccountForm()
    mes_exists = ""
    if request.method == "POST":
        form = FindSubmissionAccountForm(request.POST)
        if form.is_valid():
            print("moamaoamao")
            ega_box_number = request.POST['ega_box']
            # exists submission boxes
            exists_sb = SubmissionBoxes.objects.filter(
                ega_box_number=ega_box_number).count()
            if exists_sb == 1:
                return redirect('accounts:sub_detail', pk=ega_box_number)
            else:
                mes_exists = "This ega box number does not exist. Not pre-assigned."
    return render(request, 'accounts/account_find.html', {'form': form, 'mes_exists': mes_exists})


def search(request):
    # ega_box_number = request.GET.get('ega_box_number')  # diccionario

    # subboxes = SubmissionBoxes.objects.filter(ega_box_number=ega_box_number)
    # subboxes = [subbox_serializer(subbox) for subbox in subboxes]  # lista de diccionarios

    # return HttpResponse(json.dumps(subboxes), content_type='application/json')
    pass


def subbox_serializer(subbox):
    return {'ega_box_number': subbox.ega_box_number, 'rt_ticket': subbox.rt_ticket,  'emails': subbox.emails, 'received_dta': subbox.received_dta}


def account_serializer(a):
    return {'ega_box_number': a.ega_box_number,
            'account_accession': a.account_accession,
            'emails': a.emails}


def searchega(request):
    ega_box_number = request.GET.get('ega_box')
    subboxes = SubmissionBoxes.objects.filter(ega_box_number=ega_box_number)
    account = SubmissionAccounts.objects.filter(ega_box_number=ega_box_number)
    if subboxes.exists():
        account = [account_serializer(a) for a in account]
        # lista de diccionarios
        subboxes = [subbox_serializer(subbox) for subbox in subboxes]
        subboxes = subboxes+account
    return HttpResponse(json.dumps(subboxes), content_type='application/json')

def create_book_with_authors(request):
    template_name = 'store/create_with_author.html'
    if request.method == 'GET':
        bookform = BookModelForm(request.GET or None)
        formset = AuthorFormset(queryset=Author.objects.none())
    elif request.method == 'POST':
        bookform = BookModelForm(request.POST)
        formset = AuthorFormset(request.POST)
        if bookform.is_valid() and formset.is_valid():
            # first save this book, as its reference will be used in `Author`
            book = bookform.save()
            for form in formset:
                # so that `book` instance can be attached.
                author = form.save(commit=False)
                author.book = book
                author.save()
            return redirect('store:book_list')
    return render(request, template_name, {
        'bookform': bookform,
        'formset': formset,
    })


def create_account(request, pk):
    post = get_object_or_404(SubmissionBoxes, pk=pk)
    template_name = 'accounts/account_create.html'
    #
    gebt = "ega-box-"+str(pk)
    get_accession = AccountStableIDs.objects.get(ega_box_text=gebt)
    account_accession = get_accession.account_accession
    #
    if request.method == 'GET':
        form = SubmissionAccountsModelForm(instance=post)
        formset = CountryFormset(queryset=Country.objects.none())
    elif request.method == "POST":
        form = SubmissionAccountsModelForm(request.POST)
        formset = CountryFormset(request.POST)
        if form.is_valid() and formset.is_valid():
            ega_box_number = request.POST['ega_box_number']

            post = form.save(commit=False)
            post.submission_box = SubmissionBoxes.objects.get(
                ega_box_number=ega_box_number)
            post.save()
            get_accession.submission_account = post
            get_accession.save()

            for form in formset:
                # so that `book` instance can be attached.
                country = form.save(commit=False)
                country.submissionAccounts_country = post
                country.save()

            return redirect('accounts:account_list')
   
    return render(request, template_name, {
        'form': form,
        'account_accession': account_accession,
        'formset': formset
        })


def modify_submissionboxes(request, pk):
    post = get_object_or_404(SubmissionBoxes, pk=pk)
    template_name = 'accounts/subBoxacount_detail.html'
    date = post.account_opened_date
    if request.method == "POST":
        received_dta = request.POST.get('received_dta', '')
        form = ModifySubBoxesModelForm(request.POST, instance=post)
        if form.is_valid():

            ega_box_number = request.POST['ega_box_number']
            exists_account = SubmissionAccounts.objects.all().filter(
                ega_box_number=ega_box_number).exists()
            if received_dta == "on":  # solo quiere añadir cambios true>on
                if exists_account == False:
                    #
                    sb = SubmissionBoxes.objects.get(
                        ega_box_number=ega_box_number)

myega_drop_boxes/accounts/templates/accounts/accountStableIDs_list.html
{% extends "accounts/base.html" %}

{% block content %}

<h1>List AccountStableIDs </h1>
    <table class="table">
        <tr>
            <th>Ega Box Number <br> (ega-box-XXXX) </th>
            <th>Account Accession</th>
            <th>Submission Box Id </th>
            <th>Submission Account Id </th>

        </tr>
        {% for a in accountStableIDs %}
        <tr>
            <td>{{a.ega_box_text}}</td>
            <td> {{a.account_accession}}</td>
            <td> {{a.submission_boxes}}</td>
            <td> {{a.submission_account.ega_box_number }} </td>
        </tr>
        {% endfor %}
    </table>
{% endblock %}

myega_drop_boxes/accounts/templates/accounts/account_detail.html
{% extends 'accounts/base.html' %}

{% block content %}


<p> This account already exists.</p>


<h4>ega-box-{{ object.ega_box_number }}</h4>
<p> Account Accession :{{ object.account_accession }}</p>
<p>Users: {{ object.emails }}</p>
<p>Country: {{ object.country}}</p>
<p>region: {{ object.region }}</p>



{% endblock%}

myega_drop_boxes/accounts/templates/accounts/base.html
{% load static %}
<!DOCTYPE html>
<html>

<head>
    <title>EGA Submission Account</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.1/css/bootstrap.min.css"
        integrity="sha384-WskhaSGFgHYWDcbwN70/dfYBj47jz9qbsMId/iRN3ewGhXQFZCSftd1LZCfmhktB" crossorigin="anonymous">
    <link rel="stylesheet" href="//maxcdn.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap.min.css">
    <link rel="stylesheet" href="//maxcdn.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap-theme.min.css">
    <link rel="stylesheet" href="{% static 'css/style.css' %}">

</head>

<body>
    <header>
        <ul>
            <li><a href="{% url 'accounts:submissionboxes_list' %}">List All Submission Boxes (Filter)</a>
                -- <a href="{% url 'accounts:account_list' %}"> List all Submission Account</a>
                -- <a href="{% url 'accounts:numbersavailable_list' %}"> List ega box numbers availables</a>
                -- <a href="{% url 'accounts:stablesidst_list' %}"> List AccountStableIDs</a>
                --<a href="{% url 'accounts:create_submissionboxes_with_users' %}"> Assign Submission boxes</a>
                -- <a href="{% url 'accounts:find_account' %}">Find Submission boxes && Create account </a>
                </li>
        </ul>
    </header>
    <div class="container">
        {% block content %}
        {% endblock %}
    </div>


    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js"
        integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
        crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js"
        integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49"
        crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.1/js/bootstrap.min.js"
        integrity="sha384-smHYKdLADwkXOn1EmN1qk/HfnUcbVRZyYmZ4qpPea6sjB/pTJ0euyQp0Mk8ck+5T"
        crossorigin="anonymous"></script>

    {% block custom_js %}{% endblock %}
</body>

</html>

myega_drop_boxes/accounts/templates/accounts/list.html
{% extends "accounts/base.html" %}

{% block content %}
<h1>List All Submission Boxes </h1>
<table class="table">
    <tr>
        <th>Ega Box Number <br> (ega-box-XXXX) </th>
        <th>RT ticket</th>
        <th>User</th>
        <th> DTA received</th>
        <th>comments</th>
    </tr>
    {% for sb in submissionboxes %}
    <tr>
        <td>{{sb.ega_box_number}}</td>
        <td> {{sb.rt_ticket}}</td>
        <td>{{sb.emails}}</td>
        <td>{{sb.received_dta}} </td>
        <td>{{sb.comments}}</td>
    </tr>
    {% endfor %}
</table>

<!-- <form method="GET" action="{% url 'accounts:search' %}" id="searchsubbox">
    <div>
        <input type="text" name="ega_box_number">
        <input type="submit" value="search" id="butsubmit">
    </div>
</form>

<div id="datos" style="width: 300px;background-color: aqua;height: 100px;">
    

</div> -->

{% endblock %}

{% block custom_js %}
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
<script type="text/javascript">

    $(document).ready(function () {
        $("#searchsubbox").submit(function (e) {
            e.preventDefault();
            $.ajax({
                url:'/search',
                type: $(this).attr('method'),
                data: $(this).serialize(),
                success: function (json) {
                    /*console.log(json);*/
                    var html=""
                    html = '<p> '+json[0].ega_box_number+'</p>'+
                           '<p>'+json[0].rt_ticket+'</p>'+
                           '<p>'+json[0].emails+'</p>'
                    $('#datos').html(html);
                }
            })
        })
        
    });

</script>
{% endblock %}

myega_drop_boxes/accounts/templates/accounts/submission_boxes_detail.html
<h1> Request successful </h1>

<p> Congratulations!</p>  
<p> You have correctly submitted your data.</p>


<h4>ega-box-{{ object.ega_box_number }}</h4>
<p>Rt ticket:{{ object.rt_ticket }}</p>
<p>Users: {{ object.get_users }}</p>
<p>Comments: {{ object.comments}}</p>
<p>Date: {{ now|date }}</p>

<a href="{% url 'accounts:create_submissionboxes_with_users' %}"> Return Home</a>

myega_drop_boxes/accounts/templates/accounts/submission_boxes_new.html
{% extends "accounts/base.html" %}

{% block content %}

<div id="divnumbers" style="visibility: hidden;" >
    {{pstr}}
</div>

{% if heading %}
<h3>{{heading}}</h3>
{% endif %}
<form class="form-horizontal" method="POST" action="">
    {% csrf_token %}

    <div class="row spacer">
        <div class="col-2">
            {{submissionboxesform.ega_box_number.label}} <span id="startrequired"> *</span>
        </div>
        <div class="col-4">
            <div class="input-group">
                {{submissionboxesform.ega_box_number}}
                <button id="buttoncal" type="button" class="btn btn-warning">Calculate</button>
            </div>
            <span class="errormessage"> {{  submissionboxesform.ega_box_number.errors}} </span>
        </div>
    </div>
    <div class="row spacer">
        <div class="col-2">
            <label>{{submissionboxesform.rt_ticket.label}} <span id="startrequired"> *</span></label>
        </div>
        <div class="col-4">
            <div class="input-group">
                {{submissionboxesform.rt_ticket}}
            </div>
            <span class="errormessage"> {{  submissionboxesform.rt_ticket.errors}} </span>
        </div>
    </div>
    {{ formset.management_form }}
    {% for form in formset %}
    <div class="row form-row spacer">
        <div class="col-2">
            <label>{{form.email.label}} <span id="startrequired">*</span></label>
        </div>
        <div class="col-4">
            <div class="input-group">
                {{form.email}}
                <div class="input-group-append">
                    <button class="btn btn-success add-form-row">+</button>
                </div>
            </div>
            <span class="errormessage"> {{form.email.errors}} </span>
        </div>
    </div>
    {% endfor %}
    <div class="row spacer">
        <div class="col-2">
            <label>{{submissionboxesform.comments.label}}</label>
        </div>
        <div class="col-4">
            <div class="input-group">
                {{submissionboxesform.comments}}
            </div>
        </div>
    </div>
    <div class="row spacer">
        <div class="col-4 offset-2">
            <span id="startrequired">*</span>required
            <button type="submit" class="btn btn-block btn-primary" id="Create">Create</button>
        </div>
    </div>
</form>
{% endblock %}

{% block custom_js %}
<script src="https://code.jquery.com/jquery-3.2.1.slim.min.js"
    integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN"
    crossorigin="anonymous"></script>
<script type="text/javascript">
    function updateElementIndex(el, prefix, ndx) {
        var id_regex = new RegExp('(' + prefix + '-\\d+)');
        var replacement = prefix + '-' + ndx;
        if ($(el).attr("for")) $(el).attr("for", $(el).attr("for").replace(id_regex, replacement));
        if (el.id) el.id = el.id.replace(id_regex, replacement);
        if (el.name) el.name = el.name.replace(id_regex, replacement);
    }
    function cloneMore(selector, prefix) {
        var newElement = $(selector).clone(true);
        var total = $('#id_' + prefix + '-TOTAL_FORMS').val();
        newElement.find(':input:not([type=button]):not([type=submit]):not([type=reset])').each(function () {
            var name = $(this).attr('name')
            if (name) {
                name = name.replace('-' + (total - 1) + '-', '-' + total + '-');
                var id = 'id_' + name;
                $(this).attr({ 'name': name, 'id': id }).val('').removeAttr('checked');
            }
        });
        newElement.find('label').each(function () {
            var forValue = $(this).attr('for');
            if (forValue) {
                forValue = forValue.replace('-' + (total - 1) + '-', '-' + total + '-');
                $(this).attr({ 'for': forValue });
            }
        });
        total++;
        $('#id_' + prefix + '-TOTAL_FORMS').val(total);
        $(selector).after(newElement);
        var conditionRow = $('.form-row:not(:last)');
        conditionRow.find('.btn.add-form-row')
            .removeClass('btn-success').addClass('btn-danger')
            .removeClass('add-form-row').addClass('remove-form-row')
            .html('-');
        return false;
    }
    function deleteForm(prefix, btn) {
        var total = parseInt($('#id_' + prefix + '-TOTAL_FORMS').val());
        if (total > 1) {
            btn.closest('.form-row').remove();
            var forms = $('.form-row');
            $('#id_' + prefix + '-TOTAL_FORMS').val(forms.length);
            for (var i = 0, formCount = forms.length; i < formCount; i++) {
                $(forms.get(i)).find(':input').each(function () {
                    updateElementIndex(this, prefix, i);
                });
            }
        }
        return false;
    }
    $(document).on('click', '.add-form-row', function (e) {
        e.preventDefault();
        cloneMore('.form-row:last', 'form');
        return false;
    });
    $(document).on('click', '.remove-form-row', function (e) {
        e.preventDefault();
        deleteForm('form', $(this));
        return false;
    });
    $(document).ready(function () {
        $("#buttoncal").click(function () {
            var pstrnumbers= $("#divnumbers").html();
            var res = pstrnumbers.split(";");
            var num= parseInt(res[0]);
            $("#id_ega_box_number").val(num);
        });
    });

</script>
{% endblock %}